Making a Slackware Router/Gateway

  Dashamir Hoxha

             <[1]dashohoxha@yahoo.com>
          

   Copyright (C) 2005 Dashamir Hoxha. Permission is granted to copy,
   distribute and/or modify this document under the terms of the GNU Free
   Documentation License, Version 1.1 or any later version published by the
   Free Software Foundation; with no Invariant Sections, with no Front-Cover
   Texts, and with no Back-Cover Texts. A copy of the license is included in
   the section entitled "GNU Free Documentation License."

   Abstract

   This article will describe the steps to install and configure a slackware
   router which serves as a gateway for a LAN.

   ---------------------------------------------------------------------------

   Table of Contents

   [2]Introduction

                [3]Description of the Problem

                [4]The Goal

                [5]Hardware Requirements

   [6]Prepare

                [7]Get Slack

                [8]Floppy Disks

                [9]Export by NFS

   [10]Installation

                [11]Boot From Floppies

                [12]Partition the Disk

                [13]Configure the Network

                [14]Mount Slack CD by NFS

                [15]Install Using setup

                [16]References

   [17]Configuration

                [18]lilo

                [19]hostname

                [20]Subversion

                [21]Other Packages

                [22]Get the Web App

                [23]mysqld

                [24]sshd

                [25]DHCP

                [26]Network

                [27]Iptables

                [28]Trafic Control

                [29]ISA Network Interface

   [30]Web User Interface

                [31]Clients

                [32]Administrator(s)

                [33]Superuser

   [34]Appendix

                [35]GNU Free Documentation License

Introduction

  Description of the Problem

   We want to manage the network connections of a LAN. For this reason a
   special web application is constructed which can be used to manage the
   clients, expiration times, registrations, etc. This web application works
   with apache+mysql+php. Besides it, there are also some shell scripts that
   manage the configuration of the server: the network configuration, the
   firewall (allowing/disallowing clients to connect to internet). The box
   gives also DHCP and DNS service to the LAN.

  The Goal

   The goal is to install Slackware (because it has low hardware
   requirements) in an old computer and to configure it as a router/gateway,
   as described in the section above. We should make a minimal installation
   (not installing too many packages). We have to install the packages
   related to apache, mysql and PHP (in order to support the web
   application), packages related to network and firewall configuration,
   packages related to the services that the router should provide to the LAN
   (DHCP, DNS), etc.

   Assuming that the box does not have a CD-ROM drive, we will do the
   installation using floppies and network. Assuming also that the box will
   be headless (without a monitor) during its normal work, we will try also
   to enable a serial console, so that it can be accessed by a serial cable,
   in case of problems.

  Hardware Requirements

   We will assume that the computer to be installed as a router is an old
   one:

     o Pentium I CPU

     o 32MB RAM

     o 1GB HDD

     o Diskette drive

     o No CD-ROM drive

     o Two network interfaces

   The installation will be done from the network, using another computer as
   installation server, which will export by NFS the slackware CD that
   contains the installation packages.

Prepare

  Get Slack

   First get the Slackware CDs. They can be bought from somewhere or they can
   be downloaded from internet (see references). I will describe a way of
   downloading them from internet (these things are done in the installation
   server, not in the old box):

    1. Create a directory for them:

 bash$ mkdir slackware
 bash$ cd slackware/

    2. Create the file get-slack.ftp with this content:

 open ftp://ftp.bit.nl/mirror/slackware/
 cd slackware-10.2-iso
 mget -c slackware-10.2-install-*
 quit

    3. Start downloading them:

 bash$ nohup lftp -f get-slack.ftp &

    4. Check that they are downloaded correctly:

 bash$ md5sum -c slackware-10.2-install-d1.iso.md5
 bash$ md5sum -c slackware-10.2-install-d2.iso.md5

  Tip

   If you got the CDs instead, then you can copy the iso-s like this:

 bash$ dd if=/dev/cdrom of=slackware-10.2-install-d1.iso
 bash$ dd if=/dev/cdrom of=slackware-10.2-install-d2.iso

   References:

     o [36]The Slackware Linux Project: Get Slack

     o [37]Slack CDs in Tirana

  Floppy Disks

   Prepare the diskettes that will be used to start the installation (4
   diskettes are needed):

    1. Download the floppy images from the internet:

 bash$ mkdir slack-floppies
 bash$ cd slack-floppies
 bash$ lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2> cd bootdisks
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/bootdisks> get bare.i
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/bootdisks> cd ../rootdisks/
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/rootdisks> get install.1
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/rootdisks> get install.2
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/rootdisks> get network.dsk
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/rootdisks> get network.dsk.README
 lftp ftp.bit.nl:/mirror/slackware/slackware-10.2/rootdisks> quit

    2. Write the images on floppies:

 bash$ dd if=bare.i of=/dev/fd0
 bash$ dd if=install.1 of=/dev/fd0
 bash$ dd if=install.2 of=/dev/fd0
 bash$ dd if=network.dsk of=/dev/fd0

   Read also network.dsk.README .

   References:

     o [38]http://www.slackware.com/install/bootdisk.php

     o [39]http://www.slackware.com/install/rootdisk.php

  Export by NFS

   Export by NFS the slackware CD in the installation server:

    1. Extract the content of the first CD in a directory:

 bash# mkdir -p /slackware/slack1
 bash# mkdir cd1
 bash# mount -o loop slackware-10.2-install-d1.iso cd1/
 bash# cp -rf cd1/* /slackware/slack1/

    2. Add to /etc/exports this line:

 /slackware/slack1  192.168.1.0/24(ro)

    3. Restart the nfs service:

 bash# /sbin/service nfs restart

    4. Make sure that the service portmap is running:

 bash# /sbin/service portmap status
 bash# /sbin/service portmap start

    5. In case that the firewall is not properly configured, then stop it at
       all:

 bash# /sbin/service iptables stop

Installation

  Boot From Floppies

    1. Boot the bare.i bootdisk.

    2. When prompted, load the install rootdisks starting with install.1 .

    3. Log into the system with the username root .

  Partition the Disk

   Partition the drive with fdisk or cfdisk . I created a linux swap
   partition in hda1 , and the rest of the disk (at least 200MB) as root
   partition in hda2 .

  Configure the Network

    a. Start the network support system with the command network . Then
       you'll be prompted to take these actions:

         1. Insert the network.dsk support floppy.

         2. Probe for the network card automatically (recommended), or load
            the modules manually.

         3. Remove the network.dsk support floppy.

    b. Configure the network interface:

          o Set it up and assign an IP:

 root@slackware:/# ifconfig eth0 up
 root@slackware:/# ifconfig eth0 192.168.252.4 netmask 255.255.255.192

          o Check that it is configured ok:

 root@slackware:/# ifconfig
 root@slackware:/# ping 192.168.252.4
 root@slackware:/# ping 192.168.252.1

          o Add a gateway, if needed:

 root@slackware:/# route add -net default gw 192.168.252.35 dev eth0
 root@slackware:/# route
 root@slackware:/# ping 192.168.251.195

  Mount Slack CD by NFS

   In slackware, start portmap and mount the slackare CD by NFS:

 root@slackware:/# mkdir slack
 root@slackware:/# sbin/rpc.portmap
 root@slackware:/# mount 192.168.1.11:/slackware/slack1 slack1/

  Install Using setup

   Install slackware using the setup script:

    1. Start setup :

 root@slackware:/# setup

    2. Format /dev/hda1 and add it as swap.

    3. Format /dev/hda2 as ext3 and use it as a root partition.

    4. At SOURCE MEDIA SELECTION choose

         4 Install from a premounted directory

       and set /slack1/slackware as the source directory.

  Note

       Alternatively, select:

         3 Install from NFS

       Choose as the directory in the server to be mounted:
       /slackware/slack1/slackware

    5. At PACKAGE SERIES SELECTION choose only:

         A   Base Linux System
         AP  Various Applications that do not need X
         N   Networking (TCP/IP, UUCP, Mail, News)

    6. At PROMPTING MODE choose menu and then select packages further. Make
       sure that these packages are selected: mysql , dnsmasq , mod_ssl , php
       , iproute2 .

    7. Choose Yes for ENABLE HOTPLUG SUBSYSTEM AT BOOT.

    8. Install LILO at MBR.

    9. Make sure that the following services are enabled: rc.dnsmasq ,
       rc.httpd , rc.ip_forward , rc.mysqld .

   10. Finally reboot.

  References

     o [40]Slackware Installation Help

     o [41]Slackware Linux Essentials

     o [42]NFS (Network File System)

Configuration

   After installation, some things need to be fixed (because they have
   problems), and also other things need to be installed as well. These
   things are described in these section.

  lilo

   The default installation of lilo sets a timeout of 2 minutes (1200). But
   since this is a headless computer (without monitor, keyboard etc.), we
   should make it smaller, so that it expires quickly and the server
   continues the reboot.

   In the file /etc/lilo.conf , change this line:

 timeout = 30

   Then reinstall lilo:

 bash# lilo

   Now the timeout is just 3 secs. For more details about lilo.conf see: man
   lilo.conf

  hostname

   Change the hostname of the server to gateway.localnet.net . In order to do
   this, modify the files /etc/HOSTNAME and /etc/hosts to contain
   gateway.localnet.net instead of the previous value. Also give the command
   hostname gateway.localnet.net.

  Subversion

   Subversion is needed to get and update the web application of the
   gateway/router. It can be found in the Slackware CD-s, or it can be
   downloaded from the internet.

  Where to Find the Slackware Package of Subversion?

   Go to [43]http://slackware.it/en/pb/ , select the slack version
   Slackware-10.2 and the package name subversion , and then click the Search
   button. The result shows that it can be found in the directory
   slackware/d/ of the CD, or it can be downloaded from one of the Slackware
   mirrors.

   Since we have assumed that the router box does not have a CD-ROM drive, to
   access the Slackware CD's we have to mount the CD to another system, share
   it (e.g. export it by NFS) and then access it through the network. If
   there is internet connection, then it is easier to download the packages
   from the internet, and this is the way that I will describe here.

    1. Download the subversion package from one of the mirrors:

 bash# mkdir download
 bash# cd download/
 bash# wget ftp://ftp.bit.nl/mirror/slackware/slackware-10.2/slackware/d/subversion-1.2.3-i486-1.*
 bash# ls -l
 total 3184
 -rw-r--r--  1 root root 3251231 Sep  8  2005 subversion-1.2.3-i486-1.tgz
 -rw-r--r--  1 root root     189 Sep  8  2005 subversion-1.2.3-i486-1.tgz.asc
 -rw-r--r--  1 root root     597 Sep  8  2005 subversion-1.2.3-i486-1.txt

       2. Install the package:

 bash# installpkg subversion-1.2.3-i486-1.tgz

  Other Packages

   In a similar way to installing subversion , get from the internet and
   install some other packages that are required by the neccessary packages
   and tools (subversion, apache, mysql, php, etc.). Unfortunatly, the
   package managment system of Slackware does not check dependencies.
   However, fortunately, it is easy to find out what is missing, in which
   package it is included, and where to get this package from.

   For example, running svn checkout , I get this error message:

 svn: error while loading shared libraries: libxml2.so.2:
 cannot open shared object file: No such file or directory

   So, the library file libxml2.so.2 , needed by svn, is missing. Going at
   [44]http://slackware.it/en/pb/ and searching for the file libxml2.so.2 in
   Slackware-10.2 , we find out that there are two packages containing it,
   libxml2-2.6.21-i486-1 , and libxml2-2.6.22-i486-1 . The last one is a
   patched one (latest), and this is the one that we should install.
   Following its link, we find from where we can get it. The rest is the same
   as for the subversion package.

  Tip

   To get easily the location of the package, place the mouse over the http
   or ftp link, right click, and choose Copy Link Location (this is in
   Firefox, other browsers may have similar options). Then go at the terminal
   (where you are logged in the router), and click the middle button (or
   click simultaneously the left and the right buttons).

   These packages are: libidn , libxml2 , glibc-i18n , gettext-tools , mhash
   , and they can be downloaded and installed like this:

 bash# wget ftp://ftp.bit.nl/mirror/slackware/slackware-10.2/patches/packages/libxml2-2.6.22-i486-1.*
 bash# installpkg libxml2-2.6.22-i486-1.tgz
 bash# wget ftp://ftp.bit.nl/mirror/slackware/slackware-10.2/slackware/l/glibc-i18n-2.3.5-noarch-5.*
 bash# installpkg glibc-i18n-2.3.5-noarch-5.tgz
 bash# wget ftp://ftp.bit.nl/mirror/slackware/slackware-10.2/slackware/l/libidn-0.5.17-i486-1.*
 bash# installpkg libidn-0.5.17-i486-1.tgz
 bash# wget ftp://ftp.bit.nl/mirror/slackware/slackware-10.2/slackware/l/mhash-0.9.2-i486-1.*
 bash# installpkg mhash-0.9.2-i486-1.tgz
 bash# wget ftp://ftp.bit.nl/mirror/slackware/slackware-10.2/slackware/d/gettext-tools-0.14.3-i486-1.*
 bash# installpkg gettext-tools-0.14.3-i486-1.tgz

  Get the Web App

   The web application that manages the connections, clients etc. is
   retrieved by subversion from a svn repository, which could be in the local
   network or somewhere in the internet, like this:

 bash# cd /var/www/htdocs/
 bash# svn checkout svn://ma-isp.com:8080/scarlet/branches/release-2
 bash# svn checkout svn+ssh://dasho@192.168.1.111/data/svn/scarlet/branches/release-2 scarlet

   This makes easy the update/upgrade of the software.

  mysqld

   Installation of MySQL in Slackware-10.2 has some problems. It can be fixed
   using these commands:

 root@gateway:~# su - mysql
 mysql@gateway:~$ mysql_install_db

   Then start the mysql server and change the password of the root:

 mysql@gateway:~$ /etc/rc.d/rc.mysqld start
 mysql@gateway:~$ mysqladmin -u root password 'new-password'

   See also [45]Slackware guide for AMP Apache MySQL & PHP .

  sshd

   To improve security, change the port of the ssh service, at
   /etc/ssh/sshd_config:

 Port 1234

  DHCP

  Network

    network.sh

 #!/bin/bash

 /sbin/ip link set dev eth0 up
 /sbin/ip link set dev eth1 up

 /sbin/ip address flush dev eth0
 /sbin/ip address flush dev eth1

 /sbin/ip address add 192.168.0.1/24 dev eth0
 /sbin/ip address add 192.168.1.10/24 dev eth1
 /sbin/ip address add 192.168.0.98/24 dev eth1

 /sbin/ip route del 192.168.0.0/24 dev eth1
 /sbin/ip route add 192.168.0.1 dev eth1
 /sbin/ip route add default via 192.168.0.1 dev eth1

    reconfig.sh

 #!/bin/bash
 ### change the configuration of the server

 path=$(dirname $0)

 ### network and iptables
 $path/network.sh
 #$path/firewall/iptables.sh

 ### services

    test.sh

 #!/bin/bash
 ### This script is for testing any new configurations.
 ### When the server is accessed and managed remotely,
 ### something may go wrong and it is possible to lock
 ### yourself out. To avoid such troubles, this script
 ### tests any new configs and after a certain time
 ### (e.g. 60 secs) it goes back to the old (tried and true)
 ### configuration. During the sleep time you can test
 ### the new configuration and make sure that it is OK.

 firewall/iptables.sh
 /usr/sbin/iptables-save > output.txt
 sleep 16
 firewall/iptables-stop.sh
 #sleep 10
 #reboot

  Iptables

    iptables.sh

          
 #!/bin/bash
 ### this script configures the firewall

 path=$(dirname $0)
 IPT=/usr/sbin/iptables

 ### clear all the tables
 $IPT --table filter --flush
 $IPT --table filter --delete-chain
 $IPT --table nat    --flush
 $IPT --table mangle --flush

 ### accept by default anything in the OUTPUT chain
 $IPT --table filter --policy OUTPUT ACCEPT

 ### enable SNAT-ing
 $path/source-nat.sh enable eth1 192.168.0.98

 ### the rules of the INPUT chain
 $path/input-rules.sh

 ### the rules of the FORWARD chain
 $path/forward-rules.sh

 ### if there is any argument, display the rules
 if [ $# != 0 ]
 then
   /usr/sbin/iptables-save
 fi

        

    iptables-stop.sh

 #!/bin/bash
 ### this script configures the firewall
                                                                                
 path=$(dirname $0)
 IPT=/usr/sbin/iptables
                                                                                
 ### clear all the tables
 $IPT --table filter --flush
 $IPT --table filter --delete-chain
 $IPT --table nat    --flush
 $IPT --table mangle --flush
                                                                                
 ### set default policies to ACCEPT
 $IPT --table filter --policy INPUT ACCEPT
 $IPT --table filter --policy OUTPUT ACCEPT
 $IPT --table filter --policy FORWARD ACCEPT

    source-nat.sh

          
 #!/bin/bash
 # enable or disable source NAT (masquerading)

 function usage
 {
   echo "Usage: ${0} [enable|disable|list] [interface] [external_ip]"
   exit
 }

 ### check that there is one parameter
 if [ -z $1 ]; then usage; fi

 ACTION=$1
 OUT_IF=${2:-eth0}
 EXTERNAL_IP=$3

 if [ -z $EXTERNAL_IP ]
 then
   TARGET=MASQUERADE
 else
   TARGET="SNAT --to-source $EXTERNAL_IP"
 fi

 ### enable forwarding in the kernel
 echo 1 > /proc/sys/net/ipv4/ip_forward

 ### append or delete the SNAT rules
 function iptables-snat-rule
 {
   command=$1
   IPT=/usr/sbin/iptables
                                                                                
   $IPT --table nat --$command POSTROUTING \
        --out-interface $OUT_IF \
        --jump $TARGET
 }

 ### list the existing SNAT rules
 function list-snat-rules
 {
   /usr/sbin/iptables-save --table nat \
       | grep -E 'SNAT|MASQUERADE' \
       | grep --invert-match 'dport'
 }

 case $ACTION in
   enable  )  iptables-snat-rule append ;;
   disable )  iptables-snat-rule delete ;;
   *       )  list-snat-rules ;;
 esac

        

    input-rules.sh

 #!/bin/bash
 ### the rules of the INPUT chain

 path=$(dirname $0)
 IPT='/usr/sbin/iptables --table filter'
 APPEND="$IPT --append INPUT"

 ### drop anything that does not match
 $IPT --policy INPUT DROP

 ### accept anything from localhost
 $APPEND --in-interface lo --jump ACCEPT
 #$APPEND --in-interface eth1 --jump ACCEPT

 ### accept any type of icmp
 $APPEND --protocol icmp --jump ACCEPT

 ### accept already established connections
 $APPEND --match state --state ESTABLISHED,RELATED --jump ACCEPT

 ### accept port 67 (dhcp) from interface eth0
 $APPEND --in-interface eth0 --proto tcp --destination-port 67 --jump ACCEPT
 $APPEND --in-interface eth0 --proto udp --destination-port 67 --jump ACCEPT
                                                                                
 ### accept ssh (2222) from interface eth1
 $APPEND --in-interface eth1 --proto tcp --destination-port 2222 --jump ACCEPT

 ### reject anything else
 #$APPEND --jump REJECT --reject-with icmp-host-prohibited
 #
 # This is commented because the default policy will drop them anyway.
 # Also, if it is commented, the script 'port.sh' can be used to
 # accept or deny any other ports (by appending or deleting rules).
 # If it is uncommented, then any other rules that are added later
 # will come after this one, and since this one matches anything, they
 # will not be reached. The order of the rules does matter!

    forward-rules.sh

 #!/bin/bash
 ### the rules of the FORWARD chain

 path=$(dirname $0)
 IPT='/usr/sbin/iptables --table filter'
 APPEND="$IPT --append FORWARD"

 ### enable forwarding in the kernel
 echo 1 > /proc/sys/net/ipv4/ip_forward

 ### the default is to accept everything
 $IPT --policy FORWARD ACCEPT

 ### accept any type of icmp
 #$APPEND --protocol icmp --jump ACCEPT

 ### accept already established connections
 #$APPEND --match state --state ESTABLISHED,RELATED --jump ACCEPT

 ### accept everything in higher ports
 #$APPEND --proto tcp --destination-port 1024: --jump ACCEPT
 #$APPEND --proto udp --destination-port 1024: --jump ACCEPT

 ### reject anything else
 #$APPEND --jump REJECT --reject-with icmp-host-prohibited
 #
 # This is commented because the default policy will drop them anyway.
 # Also, if it is commented, the script 'port-forward.sh' can be used to
 # enable or dissable any other port forwardings. If it is uncommented,
 # then any other rules that are added later will come after this one,
 # and since this one matches anything, they will not be reached.
 # The order of the rules does matter!

    ip-forward.sh

 #!/bin/bash
 ### forward an IP to another server

 function usage
 {
   echo "Usage: $0 EXTERNAL_IP INTERNAL_IP SERVER_IP
     EXTERNAL_IP  is the IP that will be forwarded
     INTERNAL_IP  is the IP through which it is forwarded
     SERVER_IP    is the IP to which it is forwarded"
   exit
 }

 ### check that there are at least 4 parameters
 if [46] $# -lt 3 ; then usage; fi

 EXTERNAL_IP=$1  # IP that will be forwarded
 INTERNAL_IP=$2  # IP through which it is forwarded
 SERVER_IP=$3    # IP to which it is forwarded

 IPT='/usr/sbin/iptables'

 ### accept for forward everything related with $SERVER_IP
 $IPT --table filter --append FORWARD \
      --destination $SERVER_IP --jump ACCEPT
 $IPT --table filter --append FORWARD \
      --source $SERVER_IP --jump ACCEPT

 ### forward everything with destination $EXTERNAL_IP to $SERVER_IP
 $IPT --table nat --append PREROUTING \
      --destination $EXTERNAL_IP --jump DNAT --to-destination $SERVER_IP

 ### in case that $INTERNAL_IP is not gateway for $SERVER_IP
 #$IPT --table nat --append POSTROUTING \
 #     --destination $SERVERIP --jump SNAT --to-source $INTERNALIP

 ### everything comming from $SERVER_IP should be
 ### sent out to internet with source $EXTERNAL_IP
 $IPT --table nat --append POSTROUTING \
      --out-interface eth0 --source $SERVER_IP \
      --jump SNAT --to-source $EXTERNAL_IP

    port-forward.sh

          
 #!/bin/bash
 ### enables or disables port forwardings

 function usage
 {
   echo "Usage: $0 PORT EXT_IP INT_IP SERVER_IP [enable|disable|status]
     PORT       is the port that will be forwarded (like 80 or http)
     EXT_IP     is the external IP of the server
     INT_IP     is the IP of through which it will be forwarded
     SERVER_IP  is the IP of the server to which it will be forwarded"
   exit
 }

 ### check that there are at least 4 parameters
 if [ $# -lt 4 ]; then usage; fi

 PORT=$1
 EXT_IP=$2
 INT_IP=$3
 SERVER_IP=$4
 ACTION=$5

 ### append or delete the forward rules according to the parameter
 function iptables-fwd-rules
 {
   command=$1
   IPT=/usr/sbin/iptables

   # accept the port for forwarding (both tcp and udp)
   $IPT --table filter --$command FORWARD \
        --match state --state NEW \
        --match tcp --protocol tcp --dport $PORT \
        --jump ACCEPT
   $IPT --table filter --$command FORWARD \
        --match tcp --protocol tcp --dport $PORT \
        --jump ACCEPT

   ### forward the port
   $IPT --table nat --$command PREROUTING \
        --protocol tcp --destination $EXT_IP --dport $PORT \
        --jump DNAT --to-destination $SERVER_IP
   ### in case that $INT_IP is not gateway for $SERVER_IP
   ### but it doesn't hurt even if $INT_IP is gateway for it
   #$IPT --table nat --$command POSTROUTING \
   #     --protocol tcp --destination $SERVER_IP --dport $PORT \
   #     --jump SNAT --to-source $INT_IP
 }

 case $ACTION in
   enable  )  iptables-fwd-rules append ;;
   disable )  iptables-fwd-rules delete ;;
   *       )  /usr/sbin/iptables-save | grep $SERVER_IP | grep "dport $PORT" ;;
 esac

        

    port.sh

          
 #!/bin/bash
 ### Accept (or deny, or show status of) tcp connections in the given port
 ### by appending or deleting a rule in the given chain.

 function usage
 {
   echo "Usage: $0 [port] [accept|deny|status] [chain]
     where port is a number (like 80) or a service name (like http)
     and chain is: INPUT, FORWARD, LOCAL-NETWORK, SAMBA, etc."
   exit
 }

 if [ $# = 0 ]; then usage; fi

 PORT=$1
 ACTION=$2
 CHAIN=${3:-INPUT}

 ## appends or deletes a rule, according to the parameter
 function iptables-rule
 {
   command=$1
   IPT=/usr/sbin/iptables
   $IPT --table filter --$command $CHAIN \
        --match state --state NEW \
        --match tcp --protocol tcp --destination-port $PORT \
        --jump ACCEPT
   $IPT --table filter --$command $CHAIN \
        --match udp --protocol udp --destination-port $PORT \
        --jump ACCEPT
 }

 case $ACTION in
   accept )  iptables-rule append ;;
   deny   )  iptables-rule delete ;;
   *      )  /usr/sbin/iptables-save | grep $CHAIN | grep "dport $PORT" ;;
 esac

        

  Trafic Control

    trafic-control.sh

          
 #!/bin/bash

 function usage
 {
   echo "Usage: $0 [on|off]"
   exit
 }

 if [ $# = 0 ]; then usage; fi
 ACTION=$1
 RATE=${2:-220}

 ## Change 220kbit to your uplink's *actual* speed, minus a few percent.xi
 ## If you have a really fast modem, raise 'burst' a bit.

 case $ACTION in
   on )
     /sbin/tc qdisc add dev eth1 root tbf rate ${RATE}kbit latency 50ms burst 1540
     ;;
   off )
     /sbin/tc qdisc del dev eth1 root tbf rate ${RATE}kbit latency 50ms burst 1540
     ;;
   * )
     usage
     ;;
 esac

        

  ISA Network Interface

   An old Compaq box has one ISA network card and only one PCI slot. So, to
   use it as a gateway (having at least 2 network cards), we should be able
   to configure the ISA network card. The problem with the ISA cards is that
   they are old and they cannot be configured automatically by Linux. So, we
   have to tell linux the parameters related to the network card.

   The ISA network card in my Compaq is a 3Com EtherLink III (it can be seen
   written on it). Looking at [47]Supported Network Cards for Linux I see
   that it is supported, and the module for it is 3c509 . Having a look at
   /lib/modules/ I see that this module is already installed, so I have to do
   nothing about finding and installing it.

   Now I add in /etc/modules.conf the following lines (in order to load the
   module) and then reboot.

 alias eth0 3c509
 options 3c509 irq=9 io=0x0210

   How to know which are the right values that can be used for the options?
   First run the command /sbin/pnpdump . It will show the values of the
   options that can be accepted by this ISA network card. Then check as well
   the values is /proc/interrupts , /proc/irq/ , /proc/iomem , /proc/ioports
   , etc. to make sure that the values that are used for the options of this
   card are not used by some other device.

  Note

   The command /sbin/pnpdump is available if the package isapnptools is
   installed.

   References:

     o [48]Setup ISA Network Cards

     o [49]How do I tell Linux what driver to use?

     o [50]Supported Network Cards for Linux

     o [51]Using More than one Ethernet Card per Machine

Web User Interface

  Clients

   If the clients have ho access to the Internet, they get a red screen
   saying "Connect My Computer..." for any page on the web that they try to
   open. Here they can see some contact info about the service provider
   (telephone, e-mail, address, etc.). Here they are also prompted for a
   username and password, which are required in order to get internet access.
   The username and password can be obtained by contacting the ISP.

   Giving a valid username and password, the client gets internet access, and
   another red page is displayed to him, with the details of the connection,
   including the expiration time, the number of connections used, the
   bandwidth, etc. (also some information about the client, such as the name,
   username, IP of the computer, MAC address, etc.). The gateway registers
   the MAC of this computer and allows network access to this MAC, untill the
   time limit is expired. If the username or password are wrong, or if the
   expiration time is in the past, or if the maximum number of connections
   has been reached, then the registration fails.

   From the time of registration untill the time of expiration, the client
   (the registered computer) can use the internet normally. In case that the
   client would like to check the details of his connection, then he can open
   the page [52]http://gateway.localnet.net/ and use his username and
   password, in order to access the details' page.

   By clicking the "i" (info) button, the client can see more information
   about the ISP, about the usage, about the agreement between him and the
   ISP etc.

  Administrator(s)

   The administrator(s) of the router/gateway can access and manage it
   through a web interface, using [53]edit.php . It can be accessed using the
   WAN IP or the LAN IP, like [54]http://192.168.1.243/edit.php or
   [55]http://192.168.9.1/edit.php , or even using
   [56]http://gateway.localnet.net/edit.php if the computer of the admin is
   located in the LAN (behind the gateway).

   When somebody tries to access the admin interface, it is prompted for a
   username and password. These are provided to the admin by the superuser of
   the router (see [57]the section called "Users" ). After logging in
   successfully, the admin will have access to several interfaces (tabs).
   These interfaces are:

     o Clients -- used to manage the clients that get network access through
       the gateway.

     o Settings -- used to modify the settings/options of the gateway itself.

     o Misc -- several administrative tasks like backup/restore,
       update/upgrade, etc.

     o Logs -- records of several important events in the system, like adding
       a client, changing settings, etc.

   They are discussed in more details in the following sections.

    Clients

   This interface contains a list of clients that usually get internet access
   through this gateway/router (at a certain time they may have or may not
   have internet access).

   If the list is long, the filters above the list can be used to search for
   a certain client. The list can be filtered by username, realname, phone or
   e-mail. Also, if the list (or the result of filtering) is longer than 10
   items, it is displayed in pages of 10.

   The admin can delete any client of the list or he can add new clients
   (using the button Add New Client below the list). At any time, a certain
   client can be selected from the list, and its details are displayed in the
   main part of the interface (on the right). The details of the client
   include:

     o General info and contacts, like username, firstname, lastname, e-mail,
       phone, address, notes, etc. From these fields, only the username is
       needed by the system; the others are just for the benefit of the
       admin. The username is used when the clients register their computers
       (giving a username and password).

     o Information about the internet connection: the expiration time, the
       maximum number of connections, and the access code.

          o The access code is just the password that is used by the clients
            to register their computers.

          o The maximum number of connections is the maximum number of
            computers that the client can connect to internet (register)
            using this username and password.

          o The expiration time is the time limit until when the internet
            connection is allowed. It is checked by the system each hour, and
            if it is expired, the internet connection for the client is
            interrupted. The admin can change it at any time. If it is set in
            the past, then the connection of the client will be interrupted
            after at most one hour.

  Note

            After the connection for a client is interrupted, the client
            needs to register its computers again (with a username and
            password), in order to get connected again. So, it is advisable
            that they pay for the next term before the current expiration
            time.

     o The list of the client computers having internet access, whith the
       computer name, MAC address, and the registration time, for each
       computer. This list is filled automatically when each client computer
       is registered. But the admin can also add an item manually, change the
       name of an existing computer, or delete a computer from the list.

  Tip

       This can be usefull for example when a client wants to change one of
       his computers that is connected to internet. He cannot register
       another computer because the maximum number of connections is already
       reached, and he cannot remove one of the already registered computers
       because there is no interface for doing this. In this case he can
       contact the admin and ask him to disconnect (remove from the list) a
       computer with a certain name. After that he would have a free (unused)
       connection and he can connect to internet (register) another computer.

    Settings

   This interface is used to change/modify the settings of the
   gateway/router. It is almost self evident what each configuration
   parameter is used for, and there is also a comment that explains it. In
   general, the configuration parameters are these:

     o Parameters that are used for connecting the gateway to the Internet:
       WAN IP (IP of the interface connected to the WAN (eth0)), GATEWAY, and
       DNS.

     o IP of the interface connected to the LAN, (which is used as gateway by
       the LAN computers).

     o Upload and download rate limits (in Kbits/s): UPLOAD_LIMIT,
       DOWNLOAD_LIMIT.

  Warning

       The numbers that are assigned to the parameters are not the exact
       limit rates that are set on the LAN, so test the rates and use the
       trial-and-error method to find the right values. They can be tested
       using services like: [58]http://www.testmy.net/ .

   There are two sets of values for the configuration parameters: one that is
   saved in the database and one that is set in the configuration files of
   the gateway. The values of the database are displayed in the textboxes and
   can be modified and saved at any time, without disturbing the current
   configuration of the router. The values that are currently used by the
   router (in the config files) are displayed next to the textboxes (on the
   right).

   In order to change the settings of the router, they should be first
   modified and saved in the database, and then they should be applied (by
   clicking the button Apply ). The Apply button sets the values of the
   database in the configuration files and then reconfigures the router using
   the new settings.

   If you are not sure that the new settings are OK you should test them
   before applying them. This can be done using the button Test . It will ask
   for the test time (in seconds), will apply the new settings, will wait for
   the specified time, and then will revert the configuration back to the old
   settings. During the time that the new settings are active (before they
   are reverted back), you can check and make sure that everything works
   well. Because the new settings can make the gateway unstable or
   unreachable (if they are wrong), it is always a good idea to test them
   first, even if you are sure that they are OK.

  Note

   For some reason (maybe there is any bug), the settings of the
   upload/download rate limits are saved to config files but are not applied,
   when the button Apply is clicked. The router has to be rebooted so that
   these new settings are applied. The server can be rebooted from the Misc
   interface (see [59]the section called "Misc" ).

   In this interface there are also these buttons:

     o Refresh -- refreshes the page. It is different from the Refresh button
       of the browser because the button of the browser also repeats the last
       action, which can be e.g. Save or Apply, and which usually is
       udesirable.

     o Get Current Values -- gets the current values of the settings from the
       configuration files of the router and saves them in the DB.

     o Get Default Values -- saves in database some default values for each
       setting (but does not apply them!).

    Misc

   This interface is a collection of miscellaneous administrative tasks,
   which usually need to be performed by the admin of the router/gateway.
   These tasks are:

     o Backup/Restore of the Data : used to backup/restore the content of the
       database, which contains the clients, users, settings, logs, etc. To
       make a backup, click the button Make a New Backup of the Database . It
       will create a backup file which is compressed (by gzip ) and contains
       the todays date in its name. This file will be listed in the list of
       backup files, where it can be downloaded (in firefox for example, it
       can be done by right click and Save Link As... ).

  Note

       Because the name of the file contains the date, if you make a backup
       file in different days, a different file will be stored in the list
       for each day. However, if you make several backups the same day, the
       last one will overwrite the previous one.

       When a backup file needs to be restored, then it should be uploaded in
       the list first (if necessary), and then click the Restore button next
       to it (on the right). A backup file can also be removed from the list
       by clicking the X (delete) button.

     o Adjust the System Time : used to modify the time of the server.
       Because the time of the system is used to check the expiration time of
       the clients, it should be almost accurate. In case that it is not,
       then it can be adjusted here. The string above the textbox displays
       the current time (the time of the server at the moment of page
       generation; use the button Refresh This Page to refresh it). To modify
       the time, write the new date and time in the textbox and click Set
       Time . The value that is written in the textbox can be a partial time
       as well, like this: 15:35 . In this example, just the time and minutes
       will be changed and the rest will be the same as before.

     o Update the Software : will get from the maintenance server the latest
       modifications of the software, mostly any bug fixes.

     o Upgrade the Software : will upgrade the software to another release,
       which is retrived from the maintenance server through the internet.
       You will be asked for the name of the new release.

  Tip

       If something is not working after upgrading to the new release, try to
       upgrade to the previous release (downgrade) and report the problem.

     o Reboot the Server : it may be needed some times.

    Logs

   This interface displayes a list of records of important events of the
   system. Initially only the latest events are displayed (since yesterday at
   the same time as now). The time range can be changed using the fields From
   and To in the filter above the list. The events can also be filtered by
   the event name and by matching a part from the details. If the list of the
   events is long, it is displayed by pages, which are navigated using the
   links/buttons at the footer of the list.

   The events that are recorded by the system are: server bootup, user login,
   client add/remove/modify, MAC add/remove, modification of the settings,
   etc. For each event the system records also some details about it, like
   the source of the event (system, admin, etc.), the username of the admin,
   the affected things, etc.

   A printer friendly page of the list can be generated by clicking the Print
   List button (at the footer of the list). A list of the logs can also be
   sent periodically by email to the admin, if wanted, e.g. each week or
   month.

  Superuser

   The superuser is a special user that always exists (cannot be added or
   deleted) and which has unlimitted access to all the parts (interfaces) of
   the application. He has access to all the interfaces that a usual admin
   can use, and besides these there are also some interfaces that can be used
   only by him.

    Users

    SU

Appendix

  GNU Free Documentation License

   Version 1.2, November 2002

 Copyright (C) 2000,2001,2002 Free Software Foundation, Inc.
 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA

 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

    2. PREAMBLE

       The purpose of this License is to make a manual, textbook, or other
       functional and useful document free in the sense of freedom: to assure
       everyone the effective freedom to copy and redistribute it, with or
       without modifying it, either commercially or noncommercially.
       Secondarily, this License preserves for the author and publisher a way
       to get credit for their work, while not being considered responsible
       for modifications made by others.

       This License is a kind of "copyleft", which means that derivative
       works of the document must themselves be free in the same sense. It
       complements the GNU General Public License, which is a copyleft
       license designed for free software.

       We have designed this License in order to use it for manuals for free
       software, because free software needs free documentation: a free
       program should come with manuals providing the same freedoms that the
       software does. But this License is not limited to software manuals; it
       can be used for any textual work, regardless of subject matter or
       whether it is published as a printed book. We recommend this License
       principally for works whose purpose is instruction or reference.

    3. APPLICABILITY AND DEFINITIONS

       This License applies to any manual or other work, in any medium, that
       contains a notice placed by the copyright holder saying it can be
       distributed under the terms of this License. Such a notice grants a
       world-wide, royalty-free license, unlimited in duration, to use that
       work under the conditions stated herein. The "Document", below, refers
       to any such manual or work. Any member of the public is a licensee,
       and is addressed as "you". You accept the license if you copy, modify
       or distribute the work in a way requiring permission under copyright
       law.

       A "Modified Version" of the Document means any work containing the
       Document or a portion of it, either copied verbatim, or with
       modifications and/or translated into another language.

       A "Secondary Section" is a named appendix or a front-matter section of
       the Document that deals exclusively with the relationship of the
       publishers or authors of the Document to the Document's overall
       subject (or to related matters) and contains nothing that could fall
       directly within that overall subject. (Thus, if the Document is in
       part a textbook of mathematics, a Secondary Section may not explain
       any mathematics.) The relationship could be a matter of historical
       connection with the subject or with related matters, or of legal,
       commercial, philosophical, ethical or political position regarding
       them.

       The "Invariant Sections" are certain Secondary Sections whose titles
       are designated, as being those of Invariant Sections, in the notice
       that says that the Document is released under this License. If a
       section does not fit the above definition of Secondary then it is not
       allowed to be designated as Invariant. The Document may contain zero
       Invariant Sections. If the Document does not identify any Invariant
       Sections then there are none.

       The "Cover Texts" are certain short passages of text that are listed,
       as Front-Cover Texts or Back-Cover Texts, in the notice that says that
       the Document is released under this License. A Front-Cover Text may be
       at most 5 words, and a Back-Cover Text may be at most 25 words.

       A "Transparent" copy of the Document means a machine-readable copy,
       represented in a format whose specification is available to the
       general public, that is suitable for revising the document
       straightforwardly with generic text editors or (for images composed of
       pixels) generic paint programs or (for drawings) some widely available
       drawing editor, and that is suitable for input to text formatters or
       for automatic translation to a variety of formats suitable for input
       to text formatters. A copy made in an otherwise Transparent file
       format whose markup, or absence of markup, has been arranged to thwart
       or discourage subsequent modification by readers is not Transparent.
       An image format is not Transparent if used for any substantial amount
       of text. A copy that is not "Transparent" is called "Opaque".

       Examples of suitable formats for Transparent copies include plain
       ascii without markup, Texinfo input format, LaTeX input format, SGML
       or XML using a publicly available DTD, and standard-conforming simple
       HTML, PostScript or PDF designed for human modification. Examples of
       transparent image formats include PNG, XCF and JPG. Opaque formats
       include proprietary formats that can be read and edited only by
       proprietary word processors, SGML or XML for which the DTD and/or
       processing tools are not generally available, and the
       machine-generated HTML, PostScript or PDF produced by some word
       processors for output purposes only.

       The "Title Page" means, for a printed book, the title page itself,
       plus such following pages as are needed to hold, legibly, the material
       this License requires to appear in the title page. For works in
       formats which do not have any title page as such, "Title Page" means
       the text near the most prominent appearance of the work's title,
       preceding the beginning of the body of the text.

       A section "Entitled XYZ" means a named subunit of the Document whose
       title either is precisely XYZ or contains XYZ in parentheses following
       text that translates XYZ in another language. (Here XYZ stands for a
       specific section name mentioned below, such as "Acknowledgements",
       "Dedications", "Endorsements", or "History".) To "Preserve the Title"
       of such a section when you modify the Document means that it remains a
       section "Entitled XYZ" according to this definition.

       The Document may include Warranty Disclaimers next to the notice which
       states that this License applies to the Document. These Warranty
       Disclaimers are considered to be included by reference in this
       License, but only as regards disclaiming warranties: any other
       implication that these Warranty Disclaimers may have is void and has
       no effect on the meaning of this License.

    4. VERBATIM COPYING

       You may copy and distribute the Document in any medium, either
       commercially or noncommercially, provided that this License, the
       copyright notices, and the license notice saying this License applies
       to the Document are reproduced in all copies, and that you add no
       other conditions whatsoever to those of this License. You may not use
       technical measures to obstruct or control the reading or further
       copying of the copies you make or distribute. However, you may accept
       compensation in exchange for copies. If you distribute a large enough
       number of copies you must also follow the conditions in section 3.

       You may also lend copies, under the same conditions stated above, and
       you may publicly display copies.

    5. COPYING IN QUANTITY

       If you publish printed copies (or copies in media that commonly have
       printed covers) of the Document, numbering more than 100, and the
       Document's license notice requires Cover Texts, you must enclose the
       copies in covers that carry, clearly and legibly, all these Cover
       Texts: Front-Cover Texts on the front cover, and Back-Cover Texts on
       the back cover. Both covers must also clearly and legibly identify you
       as the publisher of these copies. The front cover must present the
       full title with all words of the title equally prominent and visible.
       You may add other material on the covers in addition. Copying with
       changes limited to the covers, as long as they preserve the title of
       the Document and satisfy these conditions, can be treated as verbatim
       copying in other respects.

       If the required texts for either cover are too voluminous to fit
       legibly, you should put the first ones listed (as many as fit
       reasonably) on the actual cover, and continue the rest onto adjacent
       pages.

       If you publish or distribute Opaque copies of the Document numbering
       more than 100, you must either include a machine-readable Transparent
       copy along with each Opaque copy, or state in or with each Opaque copy
       a computer-network location from which the general network-using
       public has access to download using public-standard network protocols
       a complete Transparent copy of the Document, free of added material.
       If you use the latter option, you must take reasonably prudent steps,
       when you begin distribution of Opaque copies in quantity, to ensure
       that this Transparent copy will remain thus accessible at the stated
       location until at least one year after the last time you distribute an
       Opaque copy (directly or through your agents or retailers) of that
       edition to the public.

       It is requested, but not required, that you contact the authors of the
       Document well before redistributing any large number of copies, to
       give them a chance to provide you with an updated version of the
       Document.

    6. MODIFICATIONS

       You may copy and distribute a Modified Version of the Document under
       the conditions of sections 2 and 3 above, provided that you release
       the Modified Version under precisely this License, with the Modified
       Version filling the role of the Document, thus licensing distribution
       and modification of the Modified Version to whoever possesses a copy
       of it. In addition, you must do these things in the Modified Version:

         A. Use in the Title Page (and on the covers, if any) a title
            distinct from that of the Document, and from those of previous
            versions (which should, if there were any, be listed in the
            History section of the Document). You may use the same title as a
            previous version if the original publisher of that version gives
            permission.

         B. List on the Title Page, as authors, one or more persons or
            entities responsible for authorship of the modifications in the
            Modified Version, together with at least five of the principal
            authors of the Document (all of its principal authors, if it has
            fewer than five), unless they release you from this requirement.

         C. State on the Title page the name of the publisher of the Modified
            Version, as the publisher.

         D. Preserve all the copyright notices of the Document.

         E. Add an appropriate copyright notice for your modifications
            adjacent to the other copyright notices.

         F. Include, immediately after the copyright notices, a license
            notice giving the public permission to use the Modified Version
            under the terms of this License, in the form shown in the
            Addendum below.

         G. Preserve in that license notice the full lists of Invariant
            Sections and required Cover Texts given in the Document's license
            notice.

         H. Include an unaltered copy of this License.

         I. Preserve the section Entitled "History", Preserve its Title, and
            add to it an item stating at least the title, year, new authors,
            and publisher of the Modified Version as given on the Title Page.
            If there is no section Entitled "History" in the Document, create
            one stating the title, year, authors, and publisher of the
            Document as given on its Title Page, then add an item describing
            the Modified Version as stated in the previous sentence.

         J. Preserve the network location, if any, given in the Document for
            public access to a Transparent copy of the Document, and likewise
            the network locations given in the Document for previous versions
            it was based on. These may be placed in the "History" section.
            You may omit a network location for a work that was published at
            least four years before the Document itself, or if the original
            publisher of the version it refers to gives permission.

         K. For any section Entitled "Acknowledgements" or "Dedications",
            Preserve the Title of the section, and preserve in the section
            all the substance and tone of each of the contributor
            acknowledgements and/or dedications given therein.

         L. Preserve all the Invariant Sections of the Document, unaltered in
            their text and in their titles. Section numbers or the equivalent
            are not considered part of the section titles.

         M. Delete any section Entitled "Endorsements". Such a section may
            not be included in the Modified Version.

         N. Do not retitle any existing section to be Entitled "Endorsements"
            or to conflict in title with any Invariant Section.

         O. Preserve any Warranty Disclaimers.

       If the Modified Version includes new front-matter sections or
       appendices that qualify as Secondary Sections and contain no material
       copied from the Document, you may at your option designate some or all
       of these sections as invariant. To do this, add their titles to the
       list of Invariant Sections in the Modified Version's license notice.
       These titles must be distinct from any other section titles.

       You may add a section Entitled "Endorsements", provided it contains
       nothing but endorsements of your Modified Version by various
       parties--for example, statements of peer review or that the text has
       been approved by an organization as the authoritative definition of a
       standard.

       You may add a passage of up to five words as a Front-Cover Text, and a
       passage of up to 25 words as a Back-Cover Text, to the end of the list
       of Cover Texts in the Modified Version. Only one passage of
       Front-Cover Text and one of Back-Cover Text may be added by (or
       through arrangements made by) any one entity. If the Document already
       includes a cover text for the same cover, previously added by you or
       by arrangement made by the same entity you are acting on behalf of,
       you may not add another; but you may replace the old one, on explicit
       permission from the previous publisher that added the old one.

       The author(s) and publisher(s) of the Document do not by this License
       give permission to use their names for publicity for or to assert or
       imply endorsement of any Modified Version.

    7. COMBINING DOCUMENTS

       You may combine the Document with other documents released under this
       License, under the terms defined in section 4 above for modified
       versions, provided that you include in the combination all of the
       Invariant Sections of all of the original documents, unmodified, and
       list them all as Invariant Sections of your combined work in its
       license notice, and that you preserve all their Warranty Disclaimers.

       The combined work need only contain one copy of this License, and
       multiple identical Invariant Sections may be replaced with a single
       copy. If there are multiple Invariant Sections with the same name but
       different contents, make the title of each such section unique by
       adding at the end of it, in parentheses, the name of the original
       author or publisher of that section if known, or else a unique number.
       Make the same adjustment to the section titles in the list of
       Invariant Sections in the license notice of the combined work.

       In the combination, you must combine any sections Entitled "History"
       in the various original documents, forming one section Entitled
       "History"; likewise combine any sections Entitled "Acknowledgements",
       and any sections Entitled "Dedications". You must delete all sections
       Entitled "Endorsements."

    8. COLLECTIONS OF DOCUMENTS

       You may make a collection consisting of the Document and other
       documents released under this License, and replace the individual
       copies of this License in the various documents with a single copy
       that is included in the collection, provided that you follow the rules
       of this License for verbatim copying of each of the documents in all
       other respects.

       You may extract a single document from such a collection, and
       distribute it individually under this License, provided you insert a
       copy of this License into the extracted document, and follow this
       License in all other respects regarding verbatim copying of that
       document.

    9. AGGREGATION WITH INDEPENDENT WORKS

       A compilation of the Document or its derivatives with other separate
       and independent documents or works, in or on a volume of a storage or
       distribution medium, is called an "aggregate" if the copyright
       resulting from the compilation is not used to limit the legal rights
       of the compilation's users beyond what the individual works permit.
       When the Document is included in an aggregate, this License does not
       apply to the other works in the aggregate which are not themselves
       derivative works of the Document.

       If the Cover Text requirement of section 3 is applicable to these
       copies of the Document, then if the Document is less than one half of
       the entire aggregate, the Document's Cover Texts may be placed on
       covers that bracket the Document within the aggregate, or the
       electronic equivalent of covers if the Document is in electronic form.
       Otherwise they must appear on printed covers that bracket the whole
       aggregate.

   10. TRANSLATION

       Translation is considered a kind of modification, so you may
       distribute translations of the Document under the terms of section 4.
       Replacing Invariant Sections with translations requires special
       permission from their copyright holders, but you may include
       translations of some or all Invariant Sections in addition to the
       original versions of these Invariant Sections. You may include a
       translation of this License, and all the license notices in the
       Document, and any Warranty Disclaimers, provided that you also include
       the original English version of this License and the original versions
       of those notices and disclaimers. In case of a disagreement between
       the translation and the original version of this License or a notice
       or disclaimer, the original version will prevail.

       If a section in the Document is Entitled "Acknowledgements",
       "Dedications", or "History", the requirement (section 4) to Preserve
       its Title (section 1) will typically require changing the actual
       title.

   11. TERMINATION

       You may not copy, modify, sublicense, or distribute the Document
       except as expressly provided for under this License. Any other attempt
       to copy, modify, sublicense or distribute the Document is void, and
       will automatically terminate your rights under this License. However,
       parties who have received copies, or rights, from you under this
       License will not have their licenses terminated so long as such
       parties remain in full compliance.

   12. FUTURE REVISIONS OF THIS LICENSE

       The Free Software Foundation may publish new, revised versions of the
       GNU Free Documentation License from time to time. Such new versions
       will be similar in spirit to the present version, but may differ in
       detail to address new problems or concerns. See
       http://www.gnu.org/copyleft/.

       Each version of the License is given a distinguishing version number.
       If the Document specifies that a particular numbered version of this
       License "or any later version" applies to it, you have the option of
       following the terms and conditions either of that specified version or
       of any later version that has been published (not as a draft) by the
       Free Software Foundation. If the Document does not specify a version
       number of this License, you may choose any version ever published (not
       as a draft) by the Free Software Foundation.

    ADDENDUM: How to use this License for your documents

   To use this License in a document you have written, include a copy of the
   License in the document and put the following copyright and license
   notices just after the title page:

 Copyright (C)  year  your name.
 Permission is granted to copy, distribute and/or modify this document
 under the terms of the GNU Free Documentation License, Version 1.2
 or any later version published by the Free Software Foundation;
 with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
 Texts.  A copy of the license is included in the section entitled ``GNU
 Free Documentation License''.
 

   If you have Invariant Sections, Front-Cover Texts and Back-Cover Texts,
   replace the "with...Texts." line with this:

 with the Invariant Sections being list their titles, with
 the Front-Cover Texts being list, and with the Back-Cover Texts
 being list.
 

   If you have Invariant Sections without Cover Texts, or some other
   combination of the three, merge those two alternatives to suit the
   situation.

   If your document contains nontrivial examples of program code, we
   recommend releasing these examples in parallel under your choice of free
   software license, such as the GNU General Public License, to permit their
   use in free software.

References

   Visible links
   1. mailto:dashohoxha@yahoo.com
   2. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#intro
   3. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#problem
   4. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#goal
   5. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#requirements
   6. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#prepare
   7. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#getslack
   8. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#floppies
   9. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#export
  10. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#install
  11. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#install-boot
  12. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#install-partition
  13. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#install-network
  14. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#install-mount
  15. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#install-setup
  16. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#install-references
  17. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#config
  18. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#lilo
  19. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#hostname
  20. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#svn
  21. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#packages
  22. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#get-webapp
  23. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#mysqld
  24. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#sshd
  25. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#dhcp
  26. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#net
  27. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#iptables
  28. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#tc
  29. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#isa
  30. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#wui
  31. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#wui-client
  32. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#wui-admin
  33. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#wui-su
  34. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#appendix
  35. file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#GNU-FDL
  36. http://www.slackware.com/getslack/
  37. http://www.fastlink-internet.com/CD/slackware/
  38. http://www.slackware.com/install/bootdisk.php
  39. http://www.slackware.com/install/rootdisk.php
  40. http://www.slackware.com/install/
  41. http://www.slackware.com/book/index.php?source=book1.html
  42. http://www.slackware.com/book/index.php?source=x1304.html
  43. http://slackware.it/en/pb/
  44. http://slackware.it/en/pb/
  45. http://www.linuxquestions.org/questions/showthread.php?postid=1581433
  46. file:///tmp/xmlto.DM6807/%24#%20-lt%203%20
  47. http://www.tldp.org/HOWTO/Ethernet-HOWTO-4.html#ss4.1
  48. http://www.linuxquestions.org/questions/showthread.php?t=162400
  49. http://www.ibiblio.org/pub/Linux/docs/HOWTO/other-formats/html%5C_single/Ethernet-HOWTO.html#ss2.1
  50. http://www.linuxdocs.org/HOWTOs/Hardware-HOWTO/nic.html
  51. http://www.ibiblio.org/pub/Linux/docs/HOWTO/other-formats/html%5C_single/Ethernet-HOWTO.html#ss2.4
  52. http://gateway.localnet.net/
  53. file:///tmp/xmlto.DM6807/edit.php
  54. http://192.168.1.243/edit.php
  55. http://192.168.9.1/edit.php
  56. http://gateway.localnet.net/edit.php
  57. Users
	file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#wui-su-users
  58. http://www.testmy.net/
  59. Misc
	file:///tmp/xmlto.DM6807/slackrouter_en_xsl.proc#wui-admin-misc
